package exercises.ex_q1;

import java.util.concurrent.Callable;

public class Pizzaiolo implements Callable<Pizza> {
    private final String name;

    public Pizzaiolo(String name) {
        this.name = name;
    }

    public void serve(Pizza pizza) {
        System.out.println(name + "'s pizza is ready: pizza " + pizza.hashCode());
    }

    public Pizza makePizza() throws InterruptedException {
        Pizza pizza = new Pizza();
        pizza.prepare();
        Thread.sleep(200);
        pizza.bake();
        Thread.sleep(300);
        pizza.cut();
        Thread.sleep(100);
        return pizza;
    }

    @Override
    public Pizza call() throws Exception {
        System.out.println("Thread " + name + " started by the executor");
        Pizza pizza = makePizza();
        System.out.println("Thread " + name + " pizza finished");
        return pizza;
    }
}
