package exercises.ex_q2;

import java.util.concurrent.RecursiveAction;
import java.util.logging.Logger;

public class CustomRecursiveAction extends RecursiveAction {
    private static final int threshold = 10;
    private String song;

    public CustomRecursiveAction(String song) {
        this.song = song;
    }

    @Override
    protected void compute() {
        Logger logger = Logger.getAnonymousLogger();
        if (song.length() <= threshold) {
            logger.info("Splitting problem");
            changeToUppercase();
        } else {
            logger.info("Problem is small enough");
            int halfSize = song.length() / 2;
            CustomRecursiveAction task1 = new CustomRecursiveAction(song.substring(0, halfSize));
            CustomRecursiveAction task2 = new CustomRecursiveAction(song.substring(halfSize));
            invokeAll(task1, task2);
            song = task1.song + task2.song;
            logger.info("Solution: " + song);
        }
    }

    protected void changeToUppercase() {
        song = song.toUpperCase();
    }
}
