package exercises.ex_s3;

import java.util.concurrent.atomic.AtomicLong;

public class AtomicTweet extends AbstractTweet {

    private AtomicLong likes = new AtomicLong(0);

    public AtomicTweet(String author, String content) {
        super(author, content);
    }

    @Override
    public void addLike() {
        likes.incrementAndGet();
    }

    @Override
    public void removeLike() {
        likes.updateAndGet(i -> i > 0 ? i - 1 : i);
    }

    @Override
    public long getLikes() {
        return likes.get();
    }
}
