package exercises.ex_v;

import exercises.Utils;

import java.util.List;
import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;

public class Team implements Runnable {
    private final String name;
    private final List<Result> results;
    private final CyclicBarrier barrier;

    public Team(int i, List<Result> results, CyclicBarrier barrier) {
        this.name = "Team " + i;
        this.results = results;
        this.barrier = barrier;
    }

    @Override
    public void run() {
        System.out.println(name + " : Started the race");
        try {
            Utils.randomSleep(1000, 5000);
        } catch (InterruptedException _) {}

        Result result = new Result(name, (int) (Math.random() * 20 + 1));
        System.out.println(name + " : Finished the race in " + result.getTime() + " hours and is waiting for other teams");
        results.add(result);
        try {
            barrier.await();
        } catch (InterruptedException | BrokenBarrierException _) {}
    }
}
