package exercises.ex_v;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;

public class TestingCyclicBarrier_PDG {
    private static int NUM_TEAMS = 20;
    public static void main(String[] args) {
        List<Result> results = Collections.synchronizedList(new ArrayList<>());
        System.out.println("Starting PDG with " + NUM_TEAMS + " teams ");
        CyclicBarrier barrier = new CyclicBarrier(NUM_TEAMS, new Referee(results));

        // Start the team threads and synchronize them.
        // Make sure finally to order to order the results and print them
        for (int i = 0; i < NUM_TEAMS; i++) {
            new Thread(new Team(i, results, barrier)).start();
        }
    }
}
