package exercises.ex_x;

import exercises.Utils;

import java.util.concurrent.Phaser;

public class FamilyMember implements Runnable {
    private final String name;
    private final Phaser phaser;
    private final int numSteps;

    public FamilyMember(String name, Phaser phaser, int numSteps) {
        this.name = name;
        this.phaser = phaser;
        this.numSteps = numSteps;
        phaser.register();
    }

    @Override
    public void run() {
        int step = 0;
        while (step < numSteps) {
            step = phaser.getPhase() + 1;
            try {
                System.out.println(name + ": Step " + step + " started");
                Utils.randomSleep(1000, 3000);
                phaser.arriveAndAwaitAdvance();
            } catch (InterruptedException e) {
                break;
            }
        }
        phaser.arriveAndDeregister();
        System.out.println(name + " has arrived");
    }
}
